{
  Renumber FormIDs of selected records starting from provided value
}
unit UserScript;

var
  slModels: TStringList;
var
  NewFormID: Cardinal;
var
  ex: IInterface;

function Initialize: integer;
begin
  NewFormID := 0;

  // list of models, ignore duplicated ones
  slModels := TStringList.Create;
  slModels.Sorted := True;
  slModels.Duplicates := dupIgnore;
end;
  
function Process(e: IInterface): integer;
var
  OldFormID: Cardinal;
  m: IInterface;
  s: string;
  i: integer;
  elEditorID: IInterface;
begin
  // file header doesn't have formid
  if Signature(e) = 'TES4' then
    Exit;
  OldFormID := GetLoadOrderFormID(e);
  elEditorID := ElementByName(e, 'EDID - Editor ID');
  //AddMessage(Format('[%s]', [Name(e)]) );
  ex := e;
//=====
  // only string fields can contain filenames
  i := DefType(e);
  if (i = dtString) or (i = dtLenString) then begin
    s := GetEditValue(e);
    if SameText(Copy(s, Length(s) - 3, 4), '.nif') then
      slModels.Add(s);
  end;
  
  // recursively process all child elements
  for i := 0 to ElementCount(e) - 1 do
    Process_Sub(ElementByIndex(e, i));
end;


function Process_Sub(e: IInterface): integer;
var
  OldFormID: Cardinal;
  m: IInterface;
  s: string;
  i: integer;
  elEditorID: IInterface;

begin
  // only string fields can contain filenames
  i := DefType(e);
  if (i = dtString) or (i = dtLenString) then begin
    s := GetEditValue(e);
    if SameText(Copy(s, Length(s) - 3, 4), '.nif') then
      slModels.Add(s);
  end;

  // recursively process all child elements
  for i := 0 to ElementCount(e) - 1 do
    Process_Sub(ElementByIndex(e, i));

end;


function Finalize: integer;
begin
  AddMessage(slModels.Text);
  //AddMessage(Format('[%s]', [Name(ex)]) );
  slModels.Free;
end;

end.
